package com.machine.coffee.Utils;

import android.util.Log;
import android.widget.Toast;

import java.util.Timer;
import java.util.TimerTask;

import com.machine.coffee.Activity.MainActivity;
import com.machine.coffee.R;

public class MessageTimer {

    //TimerTask duration.
    private static long TIMER_TASK = 5000;

    //Class object.
    private static MessageTimer message = null;

    //Activity object.
    private MainActivity mActivityCafeteira;

    //Timer variable to run within the TimerTask.
    public Timer timer;

    /**
     * Default class constructor.
     *
     * @param activityCafeteira
     */
    public MessageTimer(MainActivity activityCafeteira) {
        this.mActivityCafeteira = activityCafeteira;
    }

    /**
     * Custom class constructor following the Singleton design pattern.
     *
     * @param activityCafeteira is the activity which the Timer will be called in.
     * @return the instance.
     */
    public static MessageTimer getInstance(MainActivity activityCafeteira) {
        if (message == null) {
            message = new MessageTimer(activityCafeteira);
        }
        return message;
    }

    /**
     * Method to start the timer which will run for 5 seconds.
     */
    public void startTimerTask() {
        Log.d("DEBUG", "Starting timer!");
        timer = new Timer();

        TimerTask timerTask = new TimerTask() {
            @Override
            public void run() {
                cancelTimerTask();
                mActivityCafeteira.runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        ToastMessage.setToastMessage(mActivityCafeteira.getApplicationContext(),
                                mActivityCafeteira.getResources().
                                        getString(R.string.connection_error), Toast.LENGTH_SHORT);
                        mActivityCafeteira.turnOffSwitch();
                    }
                });
            }
        };

        timer.scheduleAtFixedRate(timerTask, TIMER_TASK, TIMER_TASK);
    }

    /**
     * Cancel TimerTask.
     */
    public void cancelTimerTask() {
        if (timer != null) {
            timer.cancel();
        }
    }
}
